<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/mytssteppvode.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>mytssteppvode.c</h1><a href="mytssteppvode_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: mytssteppvode.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="mytssteppvode_8c.html#a61c49a5366b0ae16513998a657704e37">00029</a> <span class="keywordtype">int</span> <a class="code" href="mytssteppvode_8c.html#a61c49a5366b0ae16513998a657704e37">myTSStepPVode</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <span class="keyword">extern</span> <span class="keywordtype">void</span> *<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>;
<a name="l00032"></a>00032   <span class="keyword">extern</span>      N_Vector <a class="code" href="mytscreatepvode_8c.html#a293e1df257c757d729d4b0200626e31a">nvu</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keyword">static</span> <span class="keywordtype">int</span>  nsteps=-1;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="comment">/* take 20 time steps at once</span>
<a name="l00039"></a>00039 <span class="comment">     problem: tols not increased, because devNorm gets too large</span>
<a name="l00040"></a>00040 <span class="comment">     TODO: check again if it buys any speedup</span>
<a name="l00041"></a>00041 <span class="comment">  */</span>
<a name="l00042"></a>00042   <span class="keywordflow">if</span> (nsteps&lt;0) {
<a name="l00043"></a>00043     PetscTruth flg;
<a name="l00044"></a>00044     ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-ts_nsteps&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nsteps,&amp;flg);CHKERRQ(ierr);
<a name="l00045"></a>00045     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00046"></a>00046       nsteps=1;
<a name="l00047"></a>00047       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00048"></a>00048         <span class="stringliteral">&quot;Option -ts_nsteps not found, using default value: %i\n&quot;</span>,
<a name="l00049"></a>00049         nsteps
<a name="l00050"></a>00050       );
<a name="l00051"></a>00051     }
<a name="l00052"></a>00052     <span class="keywordflow">if</span> (nsteps&lt;1) {
<a name="l00053"></a>00053       SETERRQ1(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;Option set: -ts_nsteps %i, but has to be &gt;0\n&quot;</span>,nsteps);
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   ierr = CV_SUCCESS; <span class="comment">/* just to avoid compiler warning about uninitialized var */</span>
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;nsteps;i++) {
<a name="l00059"></a>00059     ierr = CVode(cvode_mem,PETSC_MAX,nvu,&amp;gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,CV_ONE_STEP);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">if</span> (ierr != CV_SUCCESS) {
<a name="l00062"></a>00062       SETERRQ1(PETSC_ERR_LIB,<span class="stringliteral">&quot;CVode failed, ierr=%i.\n&quot;</span>,ierr);
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">/* integrate for 5 ps</span>
<a name="l00067"></a>00067 <span class="comment">     same problem as above</span>
<a name="l00068"></a>00068 <span class="comment">  ierr = CVode(</span>
<a name="l00069"></a>00069 <span class="comment">    cvode_mem,</span>
<a name="l00070"></a>00070 <span class="comment">    gdata-&gt;time+5.0e-12/gdata-&gt;tscale,</span>
<a name="l00071"></a>00071 <span class="comment">    nvu,</span>
<a name="l00072"></a>00072 <span class="comment">    &amp;gdata-&gt;time,</span>
<a name="l00073"></a>00073 <span class="comment">    NORMAL</span>
<a name="l00074"></a>00074 <span class="comment">  );</span>
<a name="l00075"></a>00075 <span class="comment">  */</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#define DEBUG</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>
<a name="l00079"></a>00079 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00081"></a>00081   <span class="comment">/* FIXME: why is VecPlaceArray not necessary with PETSc version 2.3.0? */</span>
<a name="l00082"></a>00082   <span class="comment">/* check that gdata-&gt;M points to the result */</span>
<a name="l00083"></a>00083   PetscReal *tmp;
<a name="l00084"></a>00084   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;tmp);CHKERRQ(ierr);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>  assert(tmp==NV_DATA_S(nvu));
<a name="l00088"></a>00088 <span class="preprocessor">#else</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>  assert(tmp==NV_DATA_P(nvu));
<a name="l00090"></a>00090 <span class="preprocessor">#endif</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>
<a name="l00092"></a>00092   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;tmp);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#endif </span><span class="comment">/* DEBUG */</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00097"></a>00097 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

